function [fitresult, gof] = fitBallMovement(X, Y, Z)
%CREATEFIT(X,Y,Z)
%  Create a fit.
%
%  Data for 'untitled fit 1' fit:
%      X Input : X
%      Y Input : Y
%      Z Output: Z
%  Output:
%      fitresult : a fit object representing the fit.
%      gof : structure with goodness-of fit info.
%
%  See also FIT, CFIT, SFIT.

%  Auto-generated by MATLAB on 16-Dec-2014 16:47:08


%% Fit: 'untitled fit 1'.
[xData, yData, zData] = prepareSurfaceData( X, Y, Z );

% Set up fittype and options.
ft = fittype( 'poly22' );

% Fit model to data.
[fitresult, gof] = fit( [xData, yData], zData, ft );

% Plot fit with data.
figure( 'Name', 'untitled fit 1' );
plot( fitresult, [xData, yData], zData );
title 'BallMovementApproximation'
%Label axes
xlabel 'Velocity [mm / s]'
ylabel 'Time [ms]'
zlabel 'Traveled Distance [mm]'
grid on
view( -60, 14.5 );


