T = importdata('/home/geforce/workspace/Sumatra/logs/movement_bot_0_30.csv');

pos = T(:,1:3);
vel = T(:,4:6);
acc = T(:,7:9);
setVel = T(:,10:12);
velOut = T(:,13:15);
error = T(:,16:18);
slippage = T(:,19:22);
time = T(:,27);

motorVel = T(:,23:26);


X = [vel(:,1) setVel(:,1)];
Y = velOut(:,1);

PHI = zeros(4);

phi = @(x,y) [x x.^2 y y.^2]';

for i=1:length(Y)
  PHI(i,:) = phi(X(i,1), X(i,2))';
end

theta_dur = (PHI'*PHI)^-1 * PHI' * Y;


fy_dur = @(x,y) phi(x,y)'*theta_dur;

% Create a grid of x and y points
points = linspace(-3, 3, 50);
[Xs, Ys] = meshgrid(points, points);

Zs = zeros(length(points));
for y=1:length(points)
  for x=1:length(points)
    Zs(y,x) = fy_dur(points(x),points(y));
  end
end

figure;
hold all;
plot3(X(:,1),X(:,2),Y,'.');
plot3(Xs, Ys, Zs);
xlabel('realVel');
ylabel('setVel');
zlabel('outVel');