T = importdata('/home/geforce/workspace/Sumatra/logs/movement_bot_0_34.csv');


motorSet = T(:,19:22);
motorCur = T(:,23:26);
motorOut = T(:,27:30);

delay=20;
motor=1;

X = [motorCur(1:end-delay,motor) motorSet(1+delay:end,motor)];
Y = motorCur(1+delay:end,motor);

PHI = zeros(4);

phi = @(x,y) [x x.^2 y y.^2]';

for i=1:length(Y)
  PHI(i,:) = phi(X(i,1), X(i,2))';
end

theta = (PHI'*PHI)^-1 * PHI' * Y;


fy = @(x,y) phi(x,y)'*theta;

% Create a grid of x and y points
points = linspace(-3, 3, 50);
[Xs, Ys] = meshgrid(points, points);

Zs = zeros(length(points));
for y=1:length(points)
  for x=1:length(points)
    Zs(y,x) = fy(points(x),points(y));
  end
end

figure;
hold all;
plot3(X(:,1),X(:,2),Y,'.');
plot3(Xs, Ys, Zs);
xlabel('vel_{t-1}');
ylabel('setVel_t');
zlabel('vel_t');