sampleFiles = '/home/geforce/workspace/Sumatra/logs/moduli_2015/ballChip/ballChip1429268018444_corr.csv';

if ~exist('sampleFiles','var')
  directory = '../logs/moduli_2015/ballChip/';
  dirlist = dir(strcat(directory,'*.csv'));
  sampleFiles = char(zeros(length(dirlist),length(strcat(directory, dirlist(1).name))));
  for i = 1:length(dirlist)
    sampleFiles(i,:) = strcat(directory, dirlist(i).name);
  end
else
  file = 1;
end
% file = 1;

T = importdata(sampleFiles(file,:));
% if additional values like duration are supplied, increase offset
rowOffset = 1;

cam = T(1:end-rowOffset,3);
timeNs = T(1:end-rowOffset,2);
pos = T(1:end-rowOffset,4:5);
wpVelDir = T(1:end-rowOffset,6:7);
wpVel = T(1:end-rowOffset,8);
wpPos = T(1:end-rowOffset,9:11);

dists = zeros(size(cam));
vel = zeros(size(cam));

tmp = pos(2:end,:) - pos(1:end-1,:);
dists(2:end,:) = sqrt(tmp(:,1).*tmp(:,1) + tmp(:,2).*tmp(:,2));
vel(2:end,:) = dists(2:end) ./ 1000 ./ ((timeNs(2:end) - timeNs(1:end-1)) / 1e9);

time = (timeNs-timeNs(1))/1e9;

% figure(1);
% clf;
% hold all;
% plot(time,pos(:,1));
% plot(time,pos(:,2));
% legend('x','y')
% xlabel('time [s]');
% ylabel('pos [mm]');
% title('pos');

figure(2);
clf;
hold all;
plot(wpPos(:,1),wpPos(:,2));
plot([pos(1,1);pos(end,1)],[pos(1,2);pos(end,2)]);
for c=0:3
  plot(pos(cam==c,1),pos(cam==c,2),'.');
end
legend('WP','linear line', 'cam 0','cam 1','cam 2', 'cam 3');
xlabel('pos x');
ylabel('pos y');
axis equal;
title('pos');

%   figure(3);
%   clf;
%   plot(time,wpVel);
%   xlabel('time [s]');
%   ylabel('vel [m/s]');
%   title('wp vel');

% figure(4);
% clf;
% quiver(pos(:,1),pos(:,2),-wpVelDir(:,1),-wpVelDir(:,2));
% xlabel('pos x');
% ylabel('pos y');
% axis equal;
% title('pos + vel');

%   figure(5);
%   clf;
%   plot(time,vel);
%   xlabel('time [s]');
%   ylabel('vel [m/s]');
%   title('calculated vel');

%   figure(6);
%   clf;
%   plot(time);
%   title('time');

% figure(7);
% clf;
% plot(dists);
% title('dists');

  figure(8);
  clf;
  plot(time, wpPos(:,3));
  xlabel('time [s]');
  ylabel('height [mm]');
  title('WP ball height');

% figure(9);
% clf;
% hold all;
% for c=0:3
%   plot(pos(cam==c,1),pos(cam==c,2),'.');
% end
% legend('cam 0','cam 1','cam 2', 'cam 3');
% xlabel('pos x');
% ylabel('pos y');
% axis equal;
% title('pos per cam');



file = file + 1;