/*
 * *********************************************************
 * Copyright (c) 2009 - 2014, DHBW Mannheim - Tigers Mannheim
 * Project: TIGERS - Sumatra
 * Date: Oct 31, 2014
 * Author(s): Nicolai Ommer <nicolai.ommer@gmail.com>
 * *********************************************************
 */
package edu.dhbw.mannheim.tigers.sumatra.model.modules.impls.ai.sisyphus.driver;

import java.util.List;

import edu.dhbw.mannheim.tigers.sumatra.model.data.shapes.IDrawableShape;
import edu.dhbw.mannheim.tigers.sumatra.model.data.shapes.vector.AVector3;
import edu.dhbw.mannheim.tigers.sumatra.model.data.shapes.vector.IVector3;
import edu.dhbw.mannheim.tigers.sumatra.model.data.shapes.vector.Vector3;
import edu.dhbw.mannheim.tigers.sumatra.model.data.trackedobjects.TrackedTigerBot;


/**
 * This driver will just keep the bot on its position
 * 
 * @author Nicolai Ommer <nicolai.ommer@gmail.com>
 */
public class StubPathDriver implements IPathDriver
{
	
	@Override
	public IVector3 getNextDestination(final TrackedTigerBot bot)
	{
		return getFinalDestination(bot);
	}
	
	
	@Override
	public IVector3 getNextVelocity(final TrackedTigerBot bot)
	{
		return AVector3.ZERO_VECTOR;
	}
	
	
	@Override
	public IVector3 getFinalDestination(final TrackedTigerBot bot)
	{
		return new Vector3(bot.getPos(), bot.getAngle());
	}
	
	
	@Override
	public void setMovingSpeed(final EMovingSpeed speed)
	{
	}
	
	
	@Override
	public float getRemainingTime(final TrackedTigerBot bot)
	{
		return 0;
	}
	
	
	@Override
	public void decoratePath(final TrackedTigerBot bot, final List<IDrawableShape> shapes)
	{
	}
	
	
	@Override
	public void decoratePathDebug(final TrackedTigerBot bot, final List<IDrawableShape> shapes)
	{
	}
}
