/*
 * *********************************************************
 * Copyright (c) 2009 - 2010, DHBW Mannheim - Tigers Mannheim
 * Project: TIGERS - Sumatra
 * Date: 16.05.2010
 * Authors:
 * Maren K�nemund <Orphen@fantasymail.de>,
 * Peter Birkenkampf <birkenkampf@web.de>,
 * Marcel Sauer <sauermarcel@yahoo.de>,
 * Gero
 * *********************************************************
 */
package edu.dhbw.mannheim.tigers.sumatra.model.modules.impls.worldpredictor.kalman.oextkal;

import edu.dhbw.mannheim.tigers.sumatra.model.data.modules.cam.CamBall;
import edu.dhbw.mannheim.tigers.sumatra.model.modules.impls.worldpredictor.MergedCamDetectionFrame;
import edu.dhbw.mannheim.tigers.sumatra.model.modules.impls.worldpredictor.kalman.oextkal.data.PredictionContext;
import edu.dhbw.mannheim.tigers.sumatra.model.modules.impls.worldpredictor.kalman.oextkal.data.WPCamBall;
import edu.dhbw.mannheim.tigers.sumatra.model.modules.impls.worldpredictor.kalman.oextkal.filter.IFilter;


/**
 * Prepares all new data from the incoming
 * {@link edu.dhbw.mannheim.tigers.sumatra.model.data.modules.cam.CamDetectionFrame} concerning the ball(s), and add it
 * to the {@link PredictionContext} if necessary
 */
public class BallProcessor
{
	private final PredictionContext	context;
	
	
	/**
	 * @param context
	 */
	public BallProcessor(final PredictionContext context)
	{
		this.context = context;
	}
	
	
	/**
	 * @param frame
	 */
	public void process(final MergedCamDetectionFrame frame)
	{
		CamBall ball = frame.getBall();
		final WPCamBall visionBall = new WPCamBall(ball);
		context.getBall().observation(ball.getTimestamp(), visionBall);
	}
	
	
	/**
	 */
	public void performCollisionAwareLookahead()
	{
		final IFilter ballWeKnow = context.getBall();
		for (int i = 1; i <= context.getStepCount(); i++)
		{
			ballWeKnow.performLookahead(i);
		}
	}
}
