/*
 * *********************************************************
 * Copyright (c) 2009 - 2014, DHBW Mannheim - Tigers Mannheim
 * Project: TIGERS - Sumatra
 * Date: Oct 16, 2014
 * Author(s): Nicolai Ommer <nicolai.ommer@gmail.com>
 * *********************************************************
 */
package edu.dhbw.mannheim.tigers.sumatra.util.csvexporter;

import java.util.List;


/**
 * @author Nicolai Ommer <nicolai.ommer@gmail.com>
 */
public interface IBallWatcherObserver
{
	/**
	 * This is called before the exporter is closed
	 * 
	 * @param exporter
	 */
	void beforeExport(CSVExporter exporter);
	
	
	/**
	 * Add your custom data to the list
	 * 
	 * @param data
	 */
	void onAddCustomData(List<Object> data);
	
	
	/**
	 * This is called after the csv file was saved
	 * 
	 * @param fileName
	 */
	void postProcessing(final String fileName);
}
