/*
 * *********************************************************
 * Copyright (c) 2009 - 2014, DHBW Mannheim - Tigers Mannheim
 * Project: TIGERS - Sumatra
 * Date: Dec 10, 2014
 * Author(s): Nicolai Ommer <nicolai.ommer@gmail.com>
 * *********************************************************
 */
package edu.dhbw.mannheim.tigers.sumatra.util.learning;

import Jama.Matrix;


/**
 * Interface for classes that can calculate an action from given state
 * 
 * @author Nicolai Ommer <nicolai.ommer@gmail.com>
 */
public interface IPolicyController
{
	/**
	 * @param state
	 * @return
	 */
	Matrix getControl(final Matrix state);
	
	
	/**
	 * @return
	 */
	int getStateDimension();
	
	
	/**
	 * @return
	 */
	float getDt();
}
